/**
 * \file: halak.cpp
 *
 * Obj leszrmazottainak megvalstsa
 *
 */

#include "halak.h"

/// Hal viselkedse
void Hal::lep(const Koord& pos, Ocean& oc, int it) {
    if (iter >= it) return;
    iter = it;
    kor++;
    Koord ujPos = keres(pos, oc);
    if (oc.ervenyes(ujPos)) {
        oc.replObj(ujPos, this);        // j cellba szik
        Obj* o;
        if (kor > halSzapKor)
            o = new Hal(*this);
        else
            o = new Viz;
        oc.setObj(pos, o);
     }
}

/// Cpa viselkedse
void Capa::lep(const Koord& pos, Ocean& oc, int it) {
    if (iter >= it) return;              // mr lptetk
    iter = it;
    kor++;                              // regszik
    if (nemEvett++ >= capaEhenhal) {
        ittaveg = true;                 // hen halt
        nev = 'd';
        return;
    }
    Koord ujPos = keres(pos, oc);
    if (oc.ervenyes(ujPos)) {
        if (oc.getObj(ujPos)->getmeret() > 0)
            nemEvett = 0;               // fincsi volt a kaja
        oc.replObj(ujPos, this);        // j cellba uszik
        Obj* o;
        if (kor > capaSzapKor)
            o = new Capa(*this);        // szaporodik
        else
            o = new Viz;
        oc.setObj(pos, o);
     }
}

