#ifndef HALAK_H
#define HALAK_H

/**
 * \file: halak.h
 *
 * Obj leszrmazottai
 *
 */

#include "obj.h"

class Ocean;

/// Vz
class Viz :public Obj {
public:
    Viz() :Obj('.') {}
};

/// Part vagy sziget
class Part :public Obj {
public:
    Part() :Obj('#', 10000) {}
};

/// Hal
class Hal :public Obj {
    static const int halSzapKor = 1;	// halak szaporodsi kora
    int kor;        // kora
public:
    /// 0-ra lltja a kort
    Hal() :Obj('H', 10), kor(0){}

    /// Msol - a kor kivtelvel mindent lemsol
    Hal(const Hal& h) :Obj(h), kor(0) {}

    /// Viselkedst megvalst fggvny
	/// @param pos - pozci
    /// @param oc - cen
	/// @param it - itercis lpsszm
	void lep(const Koord& pos, Ocean& oc, int it);
};

/// Cpa
class Capa :public Obj {
    static const int capaSzapKor = 5;	// cpk szaporodsi kora
    static const int capaEhenhal = 7;	// cpa hallnak kora
    int kor;        /// kora
    int nemEvett;   /// ennyi ideje nem evett
public:
    /// 0-ra lltja a kort
    Capa() :Obj('C', 100), kor(0), nemEvett(0) {}

    /// Msol - a kor kivtelvel mindent lemsol
    Capa(const Capa& h) :Obj(h), kor(0), nemEvett(h.nemEvett) {}

    /// Viselkedst megvalst fggvny
	/// @param pos - pozci
    /// @param oc - cen
	/// @param it - itercis lpsszm
	void lep(const Koord& pos, Ocean& oc, int it);
};
#endif
