#ifndef KOORD_H
#define KOORD_H

/**
 * \file: koord.h
 *
 * Koord segédobjektum
 *
 */

/// Cellarács koordinátáinak kezeléséhez
/// Koord osztály minden része publikus.
struct Koord {
public:
    enum Irany { fel, jobbra, le, balra };  /// típus az eltoláshoz
    int i;              /// sor
    int j;              /// oszlop

	/// Konstruktor:
	/// @param i - sor index
	/// @param j - oszlop index
    Koord(int i, int j) :i(i), j(j) {}

	/// Összehasonlítás
	/// @param k - jobb oldali operandus
	/// @return true - ha mindkét koordináta azonos
	bool operator==(const Koord& k) const {
		return i == k.i && j == k.j;
	}

    /// Adott iránynak megfelelően lépve új pozíciót ad
    /// @param ir - irány
    /// @return új pozíció
    Koord lep(Irany ir) const;
};

#endif
