/**
 * \file: obj.cpp
 *
 * Obj objektum és leszármazottainak megvalósítása
 *
 */

#include "obj.h"

/// Kisebb/nagyobb hal vagy víz keresése. Először halat keres.
/// @param pos - kezdő pozíció
/// @param oc - óceán
/// @param cmp - predikátum a méret összehasonlításához
/// @return - megtalált pozício - ha nincs, érvénytelen
Koord Obj::keres(const Koord& pos, Ocean& oc, cmpf_t cmp) const {
    const Koord noPos(-1,-1);			// nemlétező pozíció
    Koord talalt = noPos;				// nem talált semmit
    for (int i = 0; i < 4; i++) {       // kihasználjuk az enum tulajdonságát
        Koord ujPos = pos.lep(Koord::Irany(i));
        if (oc.ervenyes(ujPos)) {
            int m = oc.getObj(ujPos)->getmeret();
            if (m == 0) {
                if (talalt == noPos) talalt = ujPos; // megjegyzi a víz helyét
            } else if (cmp(m, meret)) { // perdikátum alapján dönt
                return ujPos;
            }
        }
    }
    return talalt;
}
