/**
 * \file: gen_array_iter.cpp
 *
 * Egyszerű program az iterátoros generikus tömb eladáson
 * bemutatott minimál változatához.
 *   + kivételkezelés példa
 */

#include <iostream>
#include "gen_array_iter.hpp"

using std::cout;
using std::endl;


int main() {
    int t0[6] = { 2, 6, 5, 10, 18, 36 };	// ebből fogunk inicializálni

    Array<int> t(t0, t0+6);			// létrehozás t0 és t0+6 közötti elemekből
    try {
        Array<int>::iterator i1, i2;

        cout << "A tomb tartalma:";	// kiírjuk
        for (i1 = t.begin(); i1 != t.end(); i1++)
            cout << " " << *i1;
        cout << endl;

	    for (i1 = t.begin(); i1 != t.end(); i1++) {
	    cout << *i1 << " osztja a kovetkezoket:";
            i2 = i1;
            for (i2++; i2 != t.end(); i2++)
                if (*i2 % *i1 == 0) cout << " " << *i2;
            cout << endl;
        }

        *i2 = 8;			// ez már hibás lesz!
    } catch (std::exception& e) {
        cout << e.what() << endl;
    }
}

