/**
 * \file: generikus_lista.hpp
 *
 *
 * Előadáson bemutatott generikus lista
 * Generilus lista
 */

#ifndef GENERIKUS_LISTA_HPP
#define GENERIKUS_LISTA_HPP

template<class T>
class Lista  {
   struct ListaElem {	// privát struktúra
     T  adat;		    // adat
     ListaElem *kov;	// pointer a következőre
     ListaElem(ListaElem *p = NULL) :kov(p) {}
     // kihasználjuk, hogy pointert másol a másoló
     ListaElem& operator=(const ListaElem); // véletlenül se használjuk
   };
   ListaElem *elso;	    // pointer az elsőre
   ListaElem *akt;	    // pointer az aktuálisra
   Lista(const Lista&); // nem használható
   Lista& operator=(const Lista&); // nem használható
      bool hasonlit(const T d1, T d2) { return(d1<d2); }
public:
   Lista() { akt = elso = new ListaElem;}	// strázsa létrehozása
   void beszur(const T& dat);      	// elem beszúrása
   bool kovetkezo(T& dat);
   ~Lista();
};

template <class T>          // tagfüggvénysablon
Lista<T>::~Lista() {
	ListaElem *p;			// futó pointer
    while ((p = elso) != NULL) {
        elso = p->kov;
        delete p;
    }
}

template <class T>          // tagfüggvénysablon
void Lista<T>::beszur(const T& dat) {
	ListaElem *p;			// futó pointer
    for (p = elso; p->kov != NULL && hasonlit(p->adat, dat); p = p->kov);
	ListaElem *uj = new ListaElem(*p); //régit másol
    p->adat = dat; p->kov = uj; // adat beírása
}

template <class T>        	// tagfüggvénysablon
bool Lista<T>::kovetkezo(T& dat) {	// következő elem
    if (akt->kov == NULL) { akt = elso; return(false); }
    dat = akt->adat;  akt = akt->kov;
    return(true);
}

#endif // GENERIKUS_LISTA_HPP
