/**
 *\file: main.cpp
 *
 * Főprogram az előadáson bemutatott iterátoros generikus lista kipróbálásához
 */

#include <iostream>
#include <cstring>
#include <iomanip>
#include "generikus_lista_iter.hpp" // sablonok

using namespace std;

template<>
bool Lista<const char*>::hasonlit(const char* s1, const char*s2) {// spec.
	return(strcmp(s1, s2) < 0);
}

/// generikus kiíró fv.
template<class Iter>
void printFv(Iter first, Iter last){
    while (first != last)
        std::cout << *first++ << ',';
    std::cout << endl;
}

int main() {
    int szamok[] = { 2, 6, 72, 12, 3, 50, 25, 100, 0 };

    std::cout << "szamok a tombbol:  ";
    printFv(szamok, szamok+8);
    Lista<int> li;
    int *p = szamok;
    while (*p != 0) li.beszur(*p++);

    std::cout << "szamok a listabol: ";
    printFv(li.begin(), li.end());

	Lista<int>::iterator i1, i2;
    for (i1 = li.begin(); i1 != li.end(); ++i1) {
      std::cout << std::setw(3) << *i1 << " osztja a kovetkezoket:";
      i2 = i1;
      for (++i2; i2 != li.end(); ++i2)
      if (*i2 % *i1 == 0)
        std::cout << " " << *i2;
      std::cout << std::endl;
    }
    Lista<const char*> ls;  	// const char* lista
	ls.beszur("Alma"); ls.beszur("Hello"); ls.beszur("Aladar");
    std::cout << "sztringek listabol: ";
    printFv(ls.begin(), ls.end());

	return(0);
}
